diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/plugin-install.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/plugin-install.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/plugin-install.php	2012-11-07 17:54:03.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/plugin-install.php	2013-07-17 16:08:05.000000000 -0500
***************
*** 81,87 ****
  
  function install_dashboard() {
  	?>
! 	<p><?php printf( __( 'Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="http://wordpress.org/extend/plugins/">WordPress Plugin Directory</a> or upload a plugin in .zip format via <a href="%s">this page</a>.' ), self_admin_url( 'plugin-install.php?tab=upload' ) ); ?></p>
  
  	<h4><?php _e('Search') ?></h4>
  	<?php install_search_form( false ); ?>
--- 81,87 ----
  
  function install_dashboard() {
  	?>
! 	<p><?php printf( __( 'Plugins extend and expand the functionality of WordPress. You may automatically install plugins from the <a href="%1$s">WordPress Plugin Directory</a> or upload a plugin in .zip format via <a href="%2$s">this page</a>.' ), 'http://wordpress.org/plugins/', self_admin_url( 'plugin-install.php?tab=upload' ) ); ?></p>
  
  	<h4><?php _e('Search') ?></h4>
  	<?php install_search_form( false ); ?>
***************
*** 116,123 ****
   * @since 2.7.0
   */
  function install_search_form( $type_selector = true ) {
! 	$type = isset($_REQUEST['type']) ? stripslashes( $_REQUEST['type'] ) : 'term';
! 	$term = isset($_REQUEST['s']) ? stripslashes( $_REQUEST['s'] ) : '';
  
  	?><form id="search-plugins" method="get" action="">
  		<input type="hidden" name="tab" value="search" />
--- 116,123 ----
   * @since 2.7.0
   */
  function install_search_form( $type_selector = true ) {
! 	$type = isset($_REQUEST['type']) ? wp_unslash( $_REQUEST['type'] ) : 'term';
! 	$term = isset($_REQUEST['s']) ? wp_unslash( $_REQUEST['s'] ) : '';
  
  	?><form id="search-plugins" method="get" action="">
  		<input type="hidden" name="tab" value="search" />
***************
*** 160,166 ****
   *
   */
  function install_plugins_favorites_form() {
! 	$user = ! empty( $_GET['user'] ) ? stripslashes( $_GET['user'] ) : get_user_option( 'wporg_favorites' );
  	?>
  	<p class="install-help"><?php _e( 'If you have marked plugins as favorites on WordPress.org, you can browse them here.' ); ?></p>
  	<form method="get" action="">
--- 160,166 ----
   *
   */
  function install_plugins_favorites_form() {
! 	$user = ! empty( $_GET['user'] ) ? wp_unslash( $_GET['user'] ) : get_user_option( 'wporg_favorites' );
  	?>
  	<p class="install-help"><?php _e( 'If you have marked plugins as favorites on WordPress.org, you can browse them here.' ); ?></p>
  	<form method="get" action="">
***************
*** 229,235 ****
  				if ( current_user_can('install_plugins') )
  					$url = wp_nonce_url(self_admin_url('update.php?action=install-plugin&plugin=' . $api->slug), 'install-plugin_' . $api->slug);
  			} else {
! 				$key = array_shift( $key = array_keys($installed_plugin) ); //Use the first plugin regardless of the name, Could have issues for multiple-plugins in one directory if they share different version numbers
  				if ( version_compare($api->version, $installed_plugin[ $key ]['Version'], '=') ){
  					$status = 'latest_installed';
  				} elseif ( version_compare($api->version, $installed_plugin[ $key ]['Version'], '<') ) {
--- 229,236 ----
  				if ( current_user_can('install_plugins') )
  					$url = wp_nonce_url(self_admin_url('update.php?action=install-plugin&plugin=' . $api->slug), 'install-plugin_' . $api->slug);
  			} else {
! 				$key = array_keys( $installed_plugin );
! 				$key = array_shift( $key ); //Use the first plugin regardless of the name, Could have issues for multiple-plugins in one directory if they share different version numbers
  				if ( version_compare($api->version, $installed_plugin[ $key ]['Version'], '=') ){
  					$status = 'latest_installed';
  				} elseif ( version_compare($api->version, $installed_plugin[ $key ]['Version'], '<') ) {
***************
*** 251,257 ****
  		}
  	}
  	if ( isset($_GET['from']) )
! 		$url .= '&amp;from=' . urlencode(stripslashes($_GET['from']));
  
  	return compact('status', 'url', 'version');
  }
--- 252,258 ----
  		}
  	}
  	if ( isset($_GET['from']) )
! 		$url .= '&amp;from=' . urlencode( wp_unslash( $_GET['from'] ) );
  
  	return compact('status', 'url', 'version');
  }
***************
*** 264,270 ****
  function install_plugin_information() {
  	global $tab;
  
! 	$api = plugins_api('plugin_information', array('slug' => stripslashes( $_REQUEST['plugin'] ) ));
  
  	if ( is_wp_error($api) )
  		wp_die($api);
--- 265,271 ----
  function install_plugin_information() {
  	global $tab;
  
! 	$api = plugins_api('plugin_information', array('slug' => wp_unslash( $_REQUEST['plugin'] ) ));
  
  	if ( is_wp_error($api) )
  		wp_die($api);
***************
*** 295,301 ****
  			$api->$key = wp_kses( $api->$key, $plugins_allowedtags );
  	}
  
! 	$section = isset($_REQUEST['section']) ? stripslashes( $_REQUEST['section'] ) : 'description'; //Default to the Description tab, Do not translate, API returns English.
  	if ( empty($section) || ! isset($api->sections[ $section ]) )
  		$section = array_shift( $section_titles = array_keys((array)$api->sections) );
  
--- 296,302 ----
  			$api->$key = wp_kses( $api->$key, $plugins_allowedtags );
  	}
  
! 	$section = isset($_REQUEST['section']) ? wp_unslash( $_REQUEST['section'] ) : 'description'; //Default to the Description tab, Do not translate, API returns English.
  	if ( empty($section) || ! isset($api->sections[ $section ]) )
  		$section = array_shift( $section_titles = array_keys((array)$api->sections) );
  
***************
*** 358,364 ****
  <?php endif; if ( ! empty($api->downloaded) ) : ?>
  			<li><strong><?php _e('Downloaded:') ?></strong> <?php printf(_n('%s time', '%s times', $api->downloaded), number_format_i18n($api->downloaded)) ?></li>
  <?php endif; if ( ! empty($api->slug) && empty($api->external) ) : ?>
! 			<li><a target="_blank" href="http://wordpress.org/extend/plugins/<?php echo $api->slug ?>/"><?php _e('WordPress.org Plugin Page &#187;') ?></a></li>
  <?php endif; if ( ! empty($api->homepage) ) : ?>
  			<li><a target="_blank" href="<?php echo $api->homepage ?>"><?php _e('Plugin Homepage &#187;') ?></a></li>
  <?php endif; ?>
--- 359,365 ----
  <?php endif; if ( ! empty($api->downloaded) ) : ?>
  			<li><strong><?php _e('Downloaded:') ?></strong> <?php printf(_n('%s time', '%s times', $api->downloaded), number_format_i18n($api->downloaded)) ?></li>
  <?php endif; if ( ! empty($api->slug) && empty($api->external) ) : ?>
! 			<li><a target="_blank" href="http://wordpress.org/plugins/<?php echo $api->slug ?>/"><?php _e('WordPress.org Plugin Page &#187;') ?></a></li>
  <?php endif; if ( ! empty($api->homepage) ) : ?>
  			<li><a target="_blank" href="<?php echo $api->homepage ?>"><?php _e('Plugin Homepage &#187;') ?></a></li>
  <?php endif; ?>
***************
*** 386,392 ****
  			else
  				$title = ucwords( str_replace( '_', ' ', $section_name ) );
  
! 			$content = links_add_base_url($content, 'http://wordpress.org/extend/plugins/' . $api->slug . '/');
  			$content = links_add_target($content, '_blank');
  
  			$san_section = esc_attr( $section_name );
--- 387,393 ----
  			else
  				$title = ucwords( str_replace( '_', ' ', $section_name ) );
  
! 			$content = links_add_base_url($content, 'http://wordpress.org/plugins/' . $api->slug . '/');
  			$content = links_add_target($content, '_blank');
  
  			$san_section = esc_attr( $section_name );
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/plugin.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/plugin.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/plugin.php	2012-11-05 18:25:18.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/plugin.php	2013-07-08 08:04:07.000000000 -0500
***************
*** 728,734 ****
  
  		$this_plugin_dir = trailingslashit( dirname($plugins_dir . $plugin_file) );
  		// If plugin is in its own directory, recursively delete the directory.
! 		if ( strpos($plugin_file, '/') && $this_plugin_dir != $plugins_dir ) //base check on if plugin includes directory separator AND that its not the root plugin folder
  			$deleted = $wp_filesystem->delete($this_plugin_dir, true);
  		else
  			$deleted = $wp_filesystem->delete($plugins_dir . $plugin_file);
--- 728,734 ----
  
  		$this_plugin_dir = trailingslashit( dirname($plugins_dir . $plugin_file) );
  		// If plugin is in its own directory, recursively delete the directory.
! 		if ( strpos($plugin_file, '/') && $this_plugin_dir != $plugins_dir ) //base check on if plugin includes directory separator AND that it's not the root plugin folder
  			$deleted = $wp_filesystem->delete($this_plugin_dir, true);
  		else
  			$deleted = $wp_filesystem->delete($plugins_dir . $plugin_file);
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/post.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/post.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-admin/includes/post.php	2013-06-21 01:02:58.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-admin/includes/post.php	2013-07-29 14:48:46.000000000 -0500
***************
*** 28,34 ****
  
  	$ptype = get_post_type_object( $post_data['post_type'] );
  
! 	if ( $update && ! current_user_can( $ptype->cap->edit_post, $post_data['ID'] ) ) {
  		if ( 'page' == $post_data['post_type'] )
  			return new WP_Error( 'edit_others_pages', __( 'You are not allowed to edit pages as this user.' ) );
  		else
--- 28,34 ----
  
  	$ptype = get_post_type_object( $post_data['post_type'] );
  
! 	if ( $update && ! current_user_can( 'edit_post', $post_data['ID'] ) ) {
  		if ( 'page' == $post_data['post_type'] )
  			return new WP_Error( 'edit_others_pages', __( 'You are not allowed to edit pages as this user.' ) );
  		else
***************
*** 172,178 ****
  	$post_data['post_mime_type'] = $post->post_mime_type;
  
  	$ptype = get_post_type_object($post_data['post_type']);
! 	if ( !current_user_can( $ptype->cap->edit_post, $post_ID ) ) {
  		if ( 'page' == $post_data['post_type'] )
  			wp_die( __('You are not allowed to edit this page.' ));
  		else
--- 172,178 ----
  	$post_data['post_mime_type'] = $post->post_mime_type;
  
  	$ptype = get_post_type_object($post_data['post_type']);
! 	if ( !current_user_can( 'edit_post', $post_ID ) ) {
  		if ( 'page' == $post_data['post_type'] )
  			wp_die( __('You are not allowed to edit this page.' ));
  		else
***************
*** 203,213 ****
  	}
  
  	// Post Formats
! 	if ( isset( $post_data['post_format'] ) ) {
! 		if ( current_theme_supports( 'post-formats', $post_data['post_format'] ) )
! 			set_post_format( $post_ID, $post_data['post_format'] );
! 		elseif ( '0' == $post_data['post_format'] )
! 			set_post_format( $post_ID, false );
  	}
  
  	// Meta Stuff
--- 203,228 ----
  	}
  
  	// Post Formats
! 	if ( isset( $post_data['post_format'] ) )
! 		set_post_format( $post_ID, $post_data['post_format'] );
! 
! 	$format_meta_urls = array( 'url', 'link_url', 'quote_source_url' );
! 	foreach ( $format_meta_urls as $format_meta_url ) {
! 		$keyed = '_format_' . $format_meta_url;
! 		if ( isset( $post_data[ $keyed ] ) )
! 			update_post_meta( $post_ID, $keyed, wp_slash( esc_url_raw( wp_unslash( $post_data[ $keyed ] ) ) ) );
! 	}
! 
! 	$format_keys = array( 'quote', 'quote_source_name', 'image', 'gallery', 'audio_embed', 'video_embed' );
! 
! 	foreach ( $format_keys as $key ) {
! 		$keyed = '_format_' . $key;
! 		if ( isset( $post_data[ $keyed ] ) ) {
! 			if ( current_user_can( 'unfiltered_html' ) )
! 				update_post_meta( $post_ID, $keyed, $post_data[ $keyed ] );
! 			else
! 				update_post_meta( $post_ID, $keyed, wp_filter_post_kses( $post_data[ $keyed ] ) );
! 		}
  	}
  
  	// Meta Stuff
***************
*** 238,248 ****
  	// Attachment stuff
  	if ( 'attachment' == $post_data['post_type'] ) {
  		if ( isset( $post_data[ '_wp_attachment_image_alt' ] ) ) {
! 			$image_alt = get_post_meta( $post_ID, '_wp_attachment_image_alt', true );
! 			if ( $image_alt != stripslashes( $post_data['_wp_attachment_image_alt'] ) ) {
! 				$image_alt = wp_strip_all_tags( stripslashes( $post_data['_wp_attachment_image_alt'] ), true );
  				// update_meta expects slashed
! 				update_post_meta( $post_ID, '_wp_attachment_image_alt', addslashes( $image_alt ) );
  			}
  		}
  
--- 253,263 ----
  	// Attachment stuff
  	if ( 'attachment' == $post_data['post_type'] ) {
  		if ( isset( $post_data[ '_wp_attachment_image_alt' ] ) ) {
! 			$image_alt = wp_unslash( $post_data['_wp_attachment_image_alt'] );
! 			if ( $image_alt != get_post_meta( $post_ID, '_wp_attachment_image_alt', true ) ) {
! 				$image_alt = wp_strip_all_tags( $image_alt, true );
  				// update_meta expects slashed
! 				update_post_meta( $post_ID, '_wp_attachment_image_alt', wp_slash( $image_alt ) );
  			}
  		}
  
***************
*** 355,373 ****
  		}
  	}
  
- 	if ( isset( $post_data['post_format'] ) ) {
- 		if ( '0' == $post_data['post_format'] )
- 			$post_data['post_format'] = false;
- 		// don't change the post format if it's not supported or not '0' (standard)
- 		elseif ( ! current_theme_supports( 'post-formats', $post_data['post_format'] ) )
- 			unset( $post_data['post_format'] );
- 	}
- 
  	$updated = $skipped = $locked = array();
  	foreach ( $post_IDs as $post_ID ) {
  		$post_type_object = get_post_type_object( get_post_type( $post_ID ) );
  
! 		if ( !isset( $post_type_object ) || ( isset($children) && in_array($post_ID, $children) ) || !current_user_can( $post_type_object->cap->edit_post, $post_ID ) ) {
  			$skipped[] = $post_ID;
  			continue;
  		}
--- 370,380 ----
  		}
  	}
  
  	$updated = $skipped = $locked = array();
  	foreach ( $post_IDs as $post_ID ) {
  		$post_type_object = get_post_type_object( get_post_type( $post_ID ) );
  
! 		if ( !isset( $post_type_object ) || ( isset($children) && in_array($post_ID, $children) ) || !current_user_can( 'edit_post', $post_ID ) ) {
  			$skipped[] = $post_ID;
  			continue;
  		}
***************
*** 412,420 ****
  			else
  				unstick_post( $post_ID );
  		}
- 
- 		if ( isset( $post_data['post_format'] ) )
- 			set_post_format( $post_ID, $post_data['post_format'] );
  	}
  
  	return array( 'updated' => $updated, 'skipped' => $skipped, 'locked' => $locked );
--- 419,424 ----
***************
*** 433,447 ****
  
  	$post_title = '';
  	if ( !empty( $_REQUEST['post_title'] ) )
! 		$post_title = esc_html( stripslashes( $_REQUEST['post_title'] ));
  
  	$post_content = '';
  	if ( !empty( $_REQUEST['content'] ) )
! 		$post_content = esc_html( stripslashes( $_REQUEST['content'] ));
  
  	$post_excerpt = '';
  	if ( !empty( $_REQUEST['excerpt'] ) )
! 		$post_excerpt = esc_html( stripslashes( $_REQUEST['excerpt'] ));
  
  	if ( $create_in_db ) {
  		$post_id = wp_insert_post( array( 'post_title' => __( 'Auto Draft' ), 'post_type' => $post_type, 'post_status' => 'auto-draft' ) );
--- 437,451 ----
  
  	$post_title = '';
  	if ( !empty( $_REQUEST['post_title'] ) )
! 		$post_title = esc_html( wp_unslash( $_REQUEST['post_title'] ));
  
  	$post_content = '';
  	if ( !empty( $_REQUEST['content'] ) )
! 		$post_content = esc_html( wp_unslash( $_REQUEST['content'] ));
  
  	$post_excerpt = '';
  	if ( !empty( $_REQUEST['excerpt'] ) )
! 		$post_excerpt = esc_html( wp_unslash( $_REQUEST['excerpt'] ));
  
  	if ( $create_in_db ) {
  		$post_id = wp_insert_post( array( 'post_title' => __( 'Auto Draft' ), 'post_type' => $post_type, 'post_status' => 'auto-draft' ) );
***************
*** 490,498 ****
  function post_exists($title, $content = '', $date = '') {
  	global $wpdb;
  
! 	$post_title = stripslashes( sanitize_post_field( 'post_title', $title, 0, 'db' ) );
! 	$post_content = stripslashes( sanitize_post_field( 'post_content', $content, 0, 'db' ) );
! 	$post_date = stripslashes( sanitize_post_field( 'post_date', $date, 0, 'db' ) );
  
  	$query = "SELECT ID FROM $wpdb->posts WHERE 1=1";
  	$args = array();
--- 494,502 ----
  function post_exists($title, $content = '', $date = '') {
  	global $wpdb;
  
! 	$post_title = wp_unslash( sanitize_post_field( 'post_title', $title, 0, 'db' ) );
! 	$post_content = wp_unslash( sanitize_post_field( 'post_content', $content, 0, 'db' ) );
! 	$post_date = wp_unslash( sanitize_post_field( 'post_date', $date, 0, 'db' ) );
  
  	$query = "SELECT ID FROM $wpdb->posts WHERE 1=1";
  	$args = array();
***************
*** 623,630 ****
  	global $wpdb;
  	$post_ID = (int) $post_ID;
  
! 	$metakeyselect = isset($_POST['metakeyselect']) ? stripslashes( trim( $_POST['metakeyselect'] ) ) : '';
! 	$metakeyinput = isset($_POST['metakeyinput']) ? stripslashes( trim( $_POST['metakeyinput'] ) ) : '';
  	$metavalue = isset($_POST['metavalue']) ? $_POST['metavalue'] : '';
  	if ( is_string( $metavalue ) )
  		$metavalue = trim( $metavalue );
--- 627,634 ----
  	global $wpdb;
  	$post_ID = (int) $post_ID;
  
! 	$metakeyselect = isset($_POST['metakeyselect']) ? wp_unslash( trim( $_POST['metakeyselect'] ) ) : '';
! 	$metakeyinput = isset($_POST['metakeyinput']) ? wp_unslash( trim( $_POST['metakeyinput'] ) ) : '';
  	$metavalue = isset($_POST['metavalue']) ? $_POST['metavalue'] : '';
  	if ( is_string( $metavalue ) )
  		$metavalue = trim( $metavalue );
***************
*** 642,648 ****
  		if ( is_protected_meta( $metakey, 'post' ) || ! current_user_can( 'add_post_meta', $post_ID, $metakey ) )
  			return false;
  
! 		$metakey = esc_sql( $metakey );
  
  		return add_post_meta( $post_ID, $metakey, $metavalue );
  	}
--- 646,652 ----
  		if ( is_protected_meta( $metakey, 'post' ) || ! current_user_can( 'add_post_meta', $post_ID, $metakey ) )
  			return false;
  
! 		$metakey = wp_slash( $metakey );
  
  		return add_post_meta( $post_ID, $metakey, $metavalue );
  	}
***************
*** 722,729 ****
   * @return unknown
   */
  function update_meta( $meta_id, $meta_key, $meta_value ) {
! 	$meta_key = stripslashes( $meta_key );
! 	$meta_value = stripslashes_deep( $meta_value );
  
  	return update_metadata_by_mid( 'post', $meta_id, $meta_value, $meta_key );
  }
--- 726,733 ----
   * @return unknown
   */
  function update_meta( $meta_id, $meta_key, $meta_value ) {
! 	$meta_key = wp_unslash( $meta_key );
! 	$meta_value = wp_unslash( $meta_value );
  
  	return update_metadata_by_mid( 'post', $meta_id, $meta_value, $meta_key );
  }
***************
*** 1002,1010 ****
  	$original_date = $post->post_date;
  	$original_name = $post->post_name;
  
! 	// Hack: get_permalink would return ugly permalink for
! 	// drafts, so we will fake, that our post is published
! 	if ( in_array($post->post_status, array('draft', 'pending')) ) {
  		$post->post_status = 'publish';
  		$post->post_name = sanitize_title($post->post_name ? $post->post_name : $post->post_title, $post->ID);
  	}
--- 1006,1013 ----
  	$original_date = $post->post_date;
  	$original_name = $post->post_name;
  
! 	// Hack: get_permalink() would return ugly permalink for drafts, so we will fake that our post is published.
! 	if ( in_array( $post->post_status, array( 'draft', 'pending' ) ) ) {
  		$post->post_status = 'publish';
  		$post->post_name = sanitize_title($post->post_name ? $post->post_name : $post->post_title, $post->ID);
  	}
***************
*** 1165,1171 ****
  	$time = $lock[0];
  	$user = isset( $lock[1] ) ? $lock[1] : get_post_meta( $post->ID, '_edit_last', true );
  
! 	$time_window = apply_filters( 'wp_check_post_lock_window', AUTOSAVE_INTERVAL * 2 );
  
  	if ( $time && $time > time() - $time_window && $user != get_current_user_id() )
  		return $user;
--- 1168,1174 ----
  	$time = $lock[0];
  	$user = isset( $lock[1] ) ? $lock[1] : get_post_meta( $post->ID, '_edit_last', true );
  
! 	$time_window = apply_filters( 'wp_check_post_lock_window', 120 );
  
  	if ( $time && $time > time() - $time_window && $user != get_current_user_id() )
  		return $user;
***************
*** 1195,1225 ****
  }
  
  /**
!  * Outputs the notice message to say that someone else is editing this post at the moment.
   *
   * @since 2.8.5
   * @return none
   */
  function _admin_notice_post_locked() {
! 	$post = get_post();
! 	$lock = explode( ':', get_post_meta( $post->ID, '_edit_lock', true ) );
! 	$user = isset( $lock[1] ) ? $lock[1] : get_post_meta( $post->ID, '_edit_last', true );
! 	$last_user = get_userdata( $user );
! 	$last_user_name = $last_user ? $last_user->display_name : __('Somebody');
  
! 	switch ($post->post_type) {
! 		case 'post':
! 			$message = __( 'Warning: %s is currently editing this post' );
! 			break;
! 		case 'page':
! 			$message = __( 'Warning: %s is currently editing this page' );
! 			break;
! 		default:
! 			$message = __( 'Warning: %s is currently editing this.' );
  	}
  
! 	$message = sprintf( $message, esc_html( $last_user_name ) );
! 	echo "<div class='error'><p>$message</p></div>";
  }
  
  /**
--- 1198,1305 ----
  }
  
  /**
!  * Outputs the HTML for the notice to say that someone else is editing or has taken over editing of this post.
   *
   * @since 2.8.5
   * @return none
   */
  function _admin_notice_post_locked() {
! 	if ( ! $post = get_post() )
! 		return;
  
! 	$user = null;
! 	if (  $user_id = wp_check_post_lock( $post->ID ) )
! 		$user = get_userdata( $user_id );
! 
! 	if ( $user ) {
! 		if ( ! apply_filters( 'show_post_locked_dialog', true, $post, $user ) )
! 			return;
! 
! 		$locked = true;
! 	} else {
! 		$locked = false;
! 	}
! 
! 	if ( $locked && ( $sendback = wp_get_referer() ) &&
! 		false === strpos( $sendback, 'post.php' ) && false === strpos( $sendback, 'post-new.php' ) ) {
! 
! 		$sendback_text = __('Go back');
! 	} else {
! 		$sendback = admin_url( 'edit.php' );
! 
! 		if ( 'post' != $post->post_type )
! 			$sendback = add_query_arg( 'post_type', $post->post_type, $sendback );
! 
! 		$sendback_text = get_post_type_object( $post->post_type )->labels->all_items;
  	}
  
! 	$hidden = $locked ? '' : ' hidden';
! 
! 	?>
! 	<div id="post-lock-dialog" class="notification-dialog-wrap<?php echo $hidden; ?>">
! 	<div class="notification-dialog-background"></div>
! 	<div class="notification-dialog">
! 	<?php
! 
! 	if ( $locked ) {
! 		if ( get_post_type_object( $post->post_type )->public ) {
! 			$preview_link = set_url_scheme( add_query_arg( 'preview', 'true', get_permalink( $post->ID ) ) );
! 
! 			if ( 'publish' == $post->post_status || $user->ID != $post->post_author ) {
! 				// Latest content is in autosave
! 				$nonce = wp_create_nonce( 'post_preview_' . $post->ID );
! 				$preview_link = add_query_arg( array( 'preview_id' => $post->ID, 'preview_nonce' => $nonce ), $preview_link );
! 			}
! 		} else {
! 			$preview_link = '';
! 		}
! 
! 		$preview_link = apply_filters( 'preview_post_link', $preview_link );
! 		$override = apply_filters( 'override_post_lock', true, $post, $user );
! 		$tab_last = $override ? '' : ' wp-tab-last';
! 
! 		?>
! 		<div class="post-locked-message">
! 		<div class="post-locked-avatar"><?php echo get_avatar( $user->ID, 64 ); ?></div>
! 		<p class="currently-editing wp-tab-first" tabindex="0"><?php echo esc_html( sprintf( __( 'This content is currently locked. If you take over, %s will be blocked from continuing to edit.' ), $user->display_name ) ); ?></p>
! 		<?php do_action( 'post_locked_dialog', $post ); ?>
! 		<p>
! 		<a class="button" href="<?php echo esc_url( $sendback ); ?>"><?php echo $sendback_text; ?></a>
! 		<?php if ( $preview_link ) { ?>
! 		<a class="button<?php echo $tab_last; ?>" href="<?php echo esc_url( $preview_link ); ?>"><?php _e('Preview'); ?></a>
! 		<?php
! 		}
! 
! 		// Allow plugins to prevent some users overriding the post lock
! 		if ( $override ) {
! 			?>
! 			<a class="button button-primary wp-tab-last" href="<?php echo esc_url( add_query_arg( 'get-post-lock', '1', get_edit_post_link( $post->ID, 'url' ) ) ); ?>"><?php _e('Take over'); ?></a>
! 			<?php
! 		}
! 
! 		?>
! 		</p>
! 		</div>
! 		<?php
! 	} else {
! 		?>
! 		<div class="post-taken-over">
! 			<div class="post-locked-avatar"></div>
! 			<p class="wp-tab-first" tabindex="0">
! 			<span class="currently-editing"></span><br>
! 			<span class="locked-saving hidden"><img src="images/wpspin_light-2x.gif" width="16" height="16" /> <?php _e('Saving revision...'); ?></span>
! 			<span class="locked-saved hidden"><?php _e('Your latest changes were saved as a revision.'); ?></span>
! 			</p>
! 			<?php do_action( 'post_lock_lost_dialog', $post ); ?>
! 			<p><a class="button button-primary wp-tab-last" href="<?php echo esc_url( $sendback ); ?>"><?php echo $sendback_text; ?></a></p>
! 		</div>
! 		<?php
! 	}
! 
! 	?>
! 	</div>
! 	</div>
! 	<?php
  }
  
  /**
***************
*** 1239,1257 ****
  	if ( is_wp_error( $translated ) )
  		return $translated;
  
! 	// Only store one autosave. If there is already an autosave, overwrite it.
! 	if ( $old_autosave = wp_get_post_autosave( $post_id ) ) {
  		$new_autosave = _wp_post_revision_fields( $_POST, true );
  		$new_autosave['ID'] = $old_autosave->ID;
! 		$new_autosave['post_author'] = get_current_user_id();
  		return wp_update_post( $new_autosave );
  	}
  
  	// _wp_put_post_revision() expects unescaped.
! 	$_POST = stripslashes_deep($_POST);
  
  	// Otherwise create the new autosave as a special post revision
! 	return _wp_put_post_revision( $_POST, true );
  }
  
  /**
--- 1319,1355 ----
  	if ( is_wp_error( $translated ) )
  		return $translated;
  
! 	$post_author = get_current_user_id();
! 
! 	// Store one autosave per author. If there is already an autosave, overwrite it.
! 	if ( $old_autosave = wp_get_post_autosave( $post_id, $post_author ) ) {
  		$new_autosave = _wp_post_revision_fields( $_POST, true );
  		$new_autosave['ID'] = $old_autosave->ID;
! 		$new_autosave['post_author'] = $post_author;
! 
! 		// If the new autosave is the same content as the post, delete the old autosave.
! 		$post = get_post( $post_id );
! 		$autosave_is_different = false;
! 		foreach ( array_keys( _wp_post_revision_fields() ) as $field ) {
! 			if ( normalize_whitespace( $new_autosave[ $field ] ) != normalize_whitespace( $post->$field ) ) {
! 				$autosave_is_different = true;
! 				break;
! 			}
! 		}
! 
! 		if ( ! $autosave_is_different ) {
! 			wp_delete_post_revision( $old_autosave->ID );
! 			return;
! 		}
! 
  		return wp_update_post( $new_autosave );
  	}
  
  	// _wp_put_post_revision() expects unescaped.
! 	$post_data = wp_unslash( $_POST );
  
  	// Otherwise create the new autosave as a special post revision
! 	return _wp_put_post_revision( $post_data, true );
  }
  
  /**
***************
*** 1291,1304 ****
  	$post = get_post($post_ID);
  
  	if ( 'page' == $post->post_type ) {
! 		if ( !current_user_can('edit_page', $post_ID) )
! 			wp_die(__('You are not allowed to edit this page.'));
  	} else {
! 		if ( !current_user_can('edit_post', $post_ID) )
! 			wp_die(__('You are not allowed to edit this post.'));
  	}
  
! 	if ( 'draft' == $post->post_status ) {
  		$id = edit_post();
  	} else { // Non drafts are not overwritten. The autosave is stored in a special post revision.
  		$id = wp_create_post_autosave( $post->ID );
--- 1389,1404 ----
  	$post = get_post($post_ID);
  
  	if ( 'page' == $post->post_type ) {
! 		if ( ! current_user_can('edit_page', $post_ID) )
! 			wp_die( __('You are not allowed to edit this page.') );
  	} else {
! 		if ( ! current_user_can('edit_post', $post_ID) )
! 			wp_die( __('You are not allowed to edit this post.') );
  	}
  
! 	$user_id = get_current_user_id();
! 	$locked = wp_check_post_lock( $post->ID );
! 	if ( ! $locked && 'draft' == $post->post_status && $user_id == $post->post_author ) {
  		$id = edit_post();
  	} else { // Non drafts are not overwritten. The autosave is stored in a special post revision.
  		$id = wp_create_post_autosave( $post->ID );
***************
*** 1309,1320 ****
  	if ( is_wp_error($id) )
  		wp_die( $id->get_error_message() );
  
! 	if ( $_POST['post_status'] == 'draft'  ) {
  		$url = add_query_arg( 'preview', 'true', get_permalink($id) );
  	} else {
  		$nonce = wp_create_nonce('post_preview_' . $id);
! 		$url = add_query_arg( array( 'preview' => 'true', 'preview_id' => $id, 'preview_nonce' => $nonce ), get_permalink($id) );
  	}
  
! 	return $url;
  }
--- 1409,1429 ----
  	if ( is_wp_error($id) )
  		wp_die( $id->get_error_message() );
  
! 	if ( ! $locked && $_POST['post_status'] == 'draft' && $user_id == $post->post_author ) {
  		$url = add_query_arg( 'preview', 'true', get_permalink($id) );
  	} else {
  		$nonce = wp_create_nonce('post_preview_' . $id);
! 		$args = array(
! 			'preview' => 'true',
! 			'preview_id' => $id,
! 			'preview_nonce' => $nonce,
! 		);
! 
! 		if ( isset( $_POST['post_format'] ) )
! 			$args['post_format'] = empty( $_POST['post_format'] ) ? 'standard' : sanitize_key( $_POST['post_format'] );
! 
! 		$url = add_query_arg( $args, get_permalink($id) );
  	}
  
! 	return apply_filters( 'preview_post_link', $url );
  }
